module LogResult (
     LogResult, closeLogLR, mapLR, mergeLR, newLR, getResLR
    ) where


data LogResult a = LRnull | LR a String

initLR :: LogResult a
initLR = LRnull

-- addLogLR :: old log info -> module title generating new log -> new result -> new log info -> result 
addLogLR :: LogResult b -> String -> a -> String -> LogResult a
addLogLR LRnull t y lg = let modinfo = concat ["Module: ",t," - executed\n\n"] in (LR y (modinfo++lg))
addLogLR (LR _ lg1) t x lg2 = let modinfo = concat ["Module: ",t," - executed\n\n"] in (LR x (concat [lg1,"\n\n",modinfo,lg2]))

getResLR :: LogResult a -> a
getResLR LRnull   = error "LogResult: no result available"
getResLR (LR x _) = x
    
getLogLR :: LogResult a -> String
getLogLR LRnull   = ""
getLogLR (LR _ y) = y
    
-- allows the addition of a standard header to the log
closeLogLR :: String -> LogResult a -> (String, a)
closeLogLR s LRnull    = (s, error "LogResult: no result available (2)")
closeLogLR s (LR x lg) = (concat [s, "\n\n", lg,"\n\n"], x)

mapLR :: String -> (a -> b) -> (b -> String) -> LogResult a -> LogResult b
mapLR mod _ _ LRnull = error ("mapLR: called from module "++mod++"; attempted map of null LogResult.")
mapLR mod f g x      = let res = (f . getResLR) x in addLogLR x mod res (g res)

mergeLR :: (a -> b -> c) -> (LogResult a) -> (LogResult b) -> (LogResult c)
mergeLR f r1 r2 = let res = f (getResLR r1) (getResLR r2) in (LR res $ concat [getLogLR r1, "\n", getLogLR r2])

newLR :: String -> (a -> String) -> a -> LogResult a
newLR mod f x = addLogLR initLR mod x (f x)
    
